

/*******************************************************************************
 * Tda CheckedPrivateAccount 
 *
 * @author    Tom Pitner
 * @version   1.00, 10.8.2005
 */
public class CheckedPrivateAccount extends PrivateAccount {

    // minimln zstatek
    private double minimal;

    /***************************************************************************
     * Konstruktor s nastavenm vlastnka, potenho zstatku
     * a minimlnho zstatku
     */
    public CheckedPrivateAccount(Person o, double b, double m) {
        super(o, b);
        minimal = m;
    }
    
    /***************************************************************************
     * Vrt minimln zstatek
     *
     * @return     Minimln zstatek
     */
    public double getMinimal() {
        return minimal;
    }
    
    /***************************************************************************
     * Pevod mezi ty nyn hld, aby zstatek na zdrojovm 
     * tu nebyl men ne minimln.
     *
     * @param  to Kam pevst
     * @param  bb Kolik pevst - mus bt kladn!
     */
    public void transferTo(Account to, double bb) {
        if(getBalance() - bb >= minimal) {
            super.transferTo(to, bb);
        }
    }

    /*************************************************************************
     * Pevod vech penz a na minimln zstatek.
     *
     * @param  to Kam pevst
     */
    public void transferTo(Account to) {
        transferTo(to, getBalance() - minimal);
    }
}
