import java.util.HashMap;
import java.util.Map;

/*******************************************************************************
 * Testovac tda PersonMapTest slou ke komplexnmu otestovn
 * rozhran Map, tdy HashMap
 *
 * @author    Tom Pitner
 * @version   1.00, 10.8.2005
 */
public class PersonMapTest extends junit.framework.TestCase {

    private Map<Person, Account> personAccountMap;
    
    private Person me;

    private Person you;

    private Person he;
    
    private Account myAccount;

    private Account yourAccount;

    /***************************************************************************
     * Vytvo test se zadanm nzvem.
     *
     * @param nzev  Nzev konstruovanho testu
     */
    public PersonMapTest(String nazev) {
        super( nazev );
    }



//== PPRAVA A KLID PPRAVKU ===============================================

    /***************************************************************************
     * Vytvoen ppravku (fixture), tj. sady objekt, s nimi budou vechny
     * testy pracovat a kter se proto vytvo ped sputnm kadho testu.         
     */
    protected void setUp() {
        personAccountMap = new HashMap<Person, Account>();
        
        me = new Person("Jan Novak", 30);
        you = new Person("Pavel Horak", 20);
        he = new Person("Libor Polak", 55);
        
        myAccount = new Account(100);
        yourAccount = new Account(5000);

        personAccountMap.put(me, myAccount);
        personAccountMap.put(you, yourAccount);
    }

    /***************************************************************************
     * klid po testu - tato metoda se spust po vykonn kadho testu.
     */
    protected void tearDown() {
    }


//== VLASTN TESTY =============================================================

    /***************************************************************************
     * Je mj et v map pod mm klem?
     */
    public void testMyAccountFound() {
        assertEquals("My Account should be in the Map.", myAccount, personAccountMap.get(me));
    }

    /***************************************************************************
     * Jeho et v map nen?
     */
    public void testHisAccountNotFound() {
        assertNull("His Account should not be in the Map.", personAccountMap.get(he));
    }

}
