import java.util.HashMap;
import java.util.Map;

/*******************************************************************************
 * Testovac tda PersonMapTest slou ke komplexnmu otestovn
 * rozhran Map, tdy HashMap
 *
 * @author    Tom Pitner
 * @version   1.00, 10.8.2005
 */
public class PersonMapTest extends junit.framework.TestCase {

    private Map<Person> personMap;
    
    private Person me;

    private Person you;

    private Person he;

    private Person she;

    /***************************************************************************
     * Vytvo test se zadanm nzvem.
     *
     * @param nzev  Nzev konstruovanho testu
     */
    public PersonMapTest(String nazev) {
        super( nazev );
    }



//== PPRAVA A KLID PPRAVKU ===============================================

    /***************************************************************************
     * Vytvoen ppravku (fixture), tj. sady objekt, s nimi budou vechny
     * testy pracovat a kter se proto vytvo ped sputnm kadho testu.         
     */
    protected void setUp() {
        personMap = new HashMap<Person>();
        
        me = new Person("Jan Novak", 30);
        you = new Person("Pavel Horak", 20);
        he = new Person("Libor Polak", 55);
        she = new Person("Anita Polakova", 51);
        
        personMap.add(me);
        personMap.add(you);
        personMap.add(he);
    }

    /***************************************************************************
     * klid po testu - tato metoda se spust po vykonn kadho testu.
     */
    protected void tearDown() {
    }


//== VLASTN TESTY =============================================================

    /***************************************************************************
     * Je 'he' na pozici 2?
     */
    public void testPersonPresent() {
        assertTrue("He should be in the Map.", personMap.contains(he));
    }

    /***************************************************************************
     * 'she' by nemla v seznamu bt.
     */
    public void testPersonNotPresent() {
        assertFalse("She should not be in the Map.", personMap.contains(she));
    }

    /***************************************************************************
     * 'you' by po vymazn neml v seznamu bt.
     */
    public void testDeletedNotPresent() {
        personMap.remove(you);
        assertFalse("You should not be in the Map.", personMap.contains(you));
    }

    /***************************************************************************
     * 'you' by po vymazn neml v seznamu bt.
     */
    public void testInsertedTwiceNotIncrementedSize() {
        int origSize = personMap.size();
        personMap.add(you);
        assertEquals("Size fo the Map should remain after duplicit insertion.", origSize, personMap.size());
    }
}
