import java.util.HashSet;
import java.util.Set;

/*******************************************************************************
 * Testovac tda PersonSetTest slou ke komplexnmu otestovn
 * rozhran Set, tdy HashSet
 *
 * @author    Tom Pitner
 * @version   1.00, 10.8.2005
 */
public class PersonSetTest extends junit.framework.TestCase {

    private Set<Person> personSet;
    
    private Person me;

    private Person you;

    private Person he;

    private Person she;

    /***************************************************************************
     * Vytvo test se zadanm nzvem.
     *
     * @param nzev  Nzev konstruovanho testu
     */
    public PersonSetTest(String nazev) {
        super( nazev );
    }



//== PPRAVA A KLID PPRAVKU ===============================================

    /***************************************************************************
     * Vytvoen ppravku (fixture), tj. sady objekt, s nimi budou vechny
     * testy pracovat a kter se proto vytvo ped sputnm kadho testu.         
     */
    protected void setUp() {
        personSet = new HashSet<Person>();
        
        me = new Person("Jan Novak", 30);
        you = new Person("Pavel Horak", 20);
        he = new Person("Libor Polak", 55);
        she = new Person("Anita Polakova", 51);
        
        personSet.add(me);
        personSet.add(you);
        personSet.add(he);
    }

    /***************************************************************************
     * klid po testu - tato metoda se spust po vykonn kadho testu.
     */
    protected void tearDown() {
    }


//== VLASTN TESTY =============================================================

    /***************************************************************************
     * Je 'he' na pozici 2?
     */
    public void testPersonPresent() {
        assertTrue("He should be in the Set.", personSet.contains(he));
    }

    /***************************************************************************
     * 'she' by nemla v seznamu bt.
     */
    public void testPersonNotPresent() {
        assertFalse("She should not be in the Set.", personSet.contains(she));
    }

    /***************************************************************************
     * 'you' by po vymazn neml v seznamu bt.
     */
    public void testDeletedNotPresent() {
        personSet.remove(you);
        assertFalse("You should not be in the Set.", personSet.contains(you));
    }

    /***************************************************************************
     * 'you' by po vymazn neml v seznamu bt.
     */
    public void testInsertedTwiceNotIncrementedSize() {
        int origSize = personSet.size();
        personSet.add(you);
        assertEquals("Size fo the Set should remain after duplicit insertion.", origSize, personSet.size());
    }
}
