

/*******************************************************************************
 * Tda Person slou k demonstraci definice jednoduch tdy 
 * s nkolika mlo vlastnostmi: promnnmi 'name' a 'age'
 * a metodami 
 *
 * @author    Tom Pitner
 * @version   1.00, 10.8.2005
 */
public class Person implements Comparable<Person> {

    // promnn jsou oznaeny jako 'private'
    private String name;
    
    private int age;

    /***************************************************************************
     * Konstruktor vytvo osobu s uvedenm jmnem a vkem
     */
    public Person(String n, int a) {
        name = n;
        age = a;
    }
    
    /***************************************************************************
     * Uspodej s dal osobou podle vku
     *
     * @param  o   Osoba, s n se bude porovnvat
     * @return     kladn slo prv kdy osoba p je ped (ni vk), 
     * 0 kdy jsou stejn star a zporn slo, kdy p m vy vk.
     */
    public int compareTo(Person p) {
        return age - p.age;
    }
    
    /***************************************************************************
     * Porovnej s dal osobou 
     *
     * @param  o   Osoba, s n se bude porovnvat
     * @return     true prv kdy jde o stejnou osobu
     */
    public boolean equals(Object o) {
        if(o instanceof Person) {
            Person p = (Person)o;
            return name.equals(p.name);
        } else {
            return false;
        }
    }
    
    /***************************************************************************
     * Vrt ha objektu.
     *
     * @return     ha objektu
     */
    public int hashCode() {
        return name.hashCode();
    }

    /***************************************************************************
     * Metoda writeInfo vype na standardn vstup
     * vechny dostupn informace o osob: jmno, vk
     */
    public void writeInfo() {
        System.out.println(this);
    }

    /***************************************************************************
     * Metoda toString vrt jako etzec
     * vechny dostupn informace o osob: jmno (vk)
     */
    public String toString() {
        return name + " ("+age + ")";
    }

}
