import java.util.Iterator;
import java.util.TreeMap;
import java.util.SortedMap;

/*******************************************************************************
 * Testovac tda PersonSortedMapTest slou ke komplexnmu otestovn
 * rozhran SortedMap, tdy HashSortedMap
 *
 * @author    Tom Pitner
 * @version   1.00, 10.8.2005
 */
public class PersonSortedMapTest extends junit.framework.TestCase {

    private SortedMap<Person, Account> personAccountSortedMap;
    
    private Person me;

    private Person you;

    private Person he;
    
    private Account myAccount;

    private Account yourAccount;

    private Account hisAccount;

    /***************************************************************************
     * Vytvo test se zadanm nzvem.
     *
     * @param nzev  Nzev konstruovanho testu
     */
    public PersonSortedMapTest(String nazev) {
        super( nazev );
    } 



//== PPRAVA A KLID PPRAVKU ===============================================

    /***************************************************************************
     * Vytvoen ppravku (fixture), tj. sady objekt, s nimi budou vechny
     * testy pracovat a kter se proto vytvo ped sputnm kadho testu.         
     */
    protected void setUp() {
        personAccountSortedMap = new TreeMap<Person, Account>();
        
        me = new Person("Jan Novak", 30);
        you = new Person("Pavel Horak", 20);
        he = new Person("Libor Polak", 55);
        
        myAccount = new Account(100);
        yourAccount = new Account(5000);
        hisAccount = new Account(0);
        
        personAccountSortedMap.put(me, myAccount);
        personAccountSortedMap.put(you, yourAccount);
        personAccountSortedMap.put(he, hisAccount);
    }

    /***************************************************************************
     * klid po testu - tato metoda se spust po vykonn kadho testu.
     */
    protected void tearDown() {
    }


//== VLASTN TESTY =============================================================

    /***************************************************************************
     * Je poad kl v map OK?
     */
    public void testPersonOrder() {
        Iterator<Person> ip = personAccountSortedMap.keySet().iterator();
        assertEquals("FirstPerson should be you.", you, ip.next());
    }
}
