import java.util.Comparator;
import java.util.Iterator;
import java.util.TreeSet;
import java.util.SortedSet;

/*******************************************************************************
 * Testovac tda PersonSortedSetTest slou ke komplexnmu otestovn
 * rozhran SortedSet, tdy TreeSet
 *
 * @author    Tom Pitner
 * @version   1.00, 10.8.2005
 */
public class PersonSortedSetTest extends junit.framework.TestCase {

    private Comparator<Person> nameComparator;

    private SortedSet<Person> personAccountSortedSet;
    
    private Person me;

    private Person you;

    private Person he;
    
    /***************************************************************************
     * Vytvo test se zadanm nzvem.
     *
     * @param nzev  Nzev konstruovanho testu
     */
    public PersonSortedSetTest(String nazev) {
        super( nazev );
    } 



//== PPRAVA A KLID PPRAVKU ===============================================

    /***************************************************************************
     * Vytvoen ppravku (fixture), tj. sady objekt, s nimi budou vechny
     * testy pracovat a kter se proto vytvo ped sputnm kadho testu.         
     */
    protected void setUp() {
        
        nameComparator = new PersonNameComparator();
        
        personAccountSortedSet = new TreeSet<Person>(nameComparator);
        
        me = new Person("Jan Novak", 30);
        you = new Person("Pavel Horak", 20);
        he = new Person("Libor Polak", 55);
        
        personAccountSortedSet.add(me);
        personAccountSortedSet.add(you);
        personAccountSortedSet.add(he);
    }

    /***************************************************************************
     * klid po testu - tato metoda se spust po vykonn kadho testu.
     */
    protected void tearDown() {
    }


//== VLASTN TESTY =============================================================

    /***************************************************************************
     * Je poad osob v mnoin OK?
     */
    public void testPersonOrder() {
        Iterator<Person> ip = personAccountSortedSet.iterator();
        assertEquals("1. Person should be me.", me, ip.next());
        assertEquals("2. Person should be he.", he, ip.next());
        assertEquals("3. Person should be you.", you, ip.next());
    }
}
